module.exports = (app) => {
  const db = require('../db')
  const jwt = require('jsonwebtoken')
  const bcrypt = require('bcrypt')
  const saltRounds = 10

  const Users = db.Mongoose.model('users', db.UserSchema, 'users')

  app.post('/login', async (req, res, next) => {
    const { username, password } = req.body

    const userDB = await Users.findOne({ username }).exec()

    if (userDB) {
      bcrypt.compare(password, userDB.password, (_, result) => {
        if (result) {
          const token = jwt.sign({ username }, 'supersecret', {
            expiresIn: 3600,
          })
          res.json({ token })
        } else {
          res.status(401).json({ error: 'incorrect password', status: 401 })
        }
      })
    } else {
      res.status(401).json({ error: 'incorrect password', status: 401 })
    }
  })

  app.post('/user', (req, res, next) => {
    const { username, password } = req.body

    bcrypt.hash(password, saltRounds, async function (err, hash) {
      if (err) res.json({ message: 'error on create' })

      const user = new Users({ username, password: hash })
      try {
        await user.save()
        res.json({ message: 'created' })
      } catch (err) {
        next(err)
      }
    })
  })
}
