const BASE_PATH = '@bands'
const TOKEN_PATH = BASE_PATH + '-token'

const storeLocalToken = (token) => {
  window.localStorage.setItem(TOKEN_PATH, token)
}

const removeLocalToken = async () => {
  await window.localStorage.removeItem(TOKEN_PATH)
}

const getLocalToken = () => {
  const token = window.localStorage.getItem(TOKEN_PATH)
  return token
}

export default {
  storeLocalToken,
  removeLocalToken,
  getLocalToken,
}
